<html>
<body>
<!-- #include file=TextFiler.asp -->
<%
' TextFiler Demo
' Written by Hunter Beanland
' http://www.geocities.com/hbeanland/
' hbeanland@yahoo.com.au

' TextFiler is a class which can read and write any single byte or unicode delimited files (CSV, Tab etc) or Fixed Width files.
' Full Microsoft Excel delimited rules are also adhered to:
' Text including commas & tabs encapsulated in double quotes are treated as 1 field ("text,text" = text,text)
' Double quotes used in encapsulation are stripped ("Text" = Text)
' 2 sets of double quotes are treated as 1 set of double quotes ("" = escaped ")
' Text in quotes can run over several lines
' Fields are outputed in a variable length single dimension array & inputed via the same.

Dim myLocalFields, ArrayIndex

'Create an 2 instances of the TextFiler class (included on line 3). Usually you will only need 1 instance, but I am going to do 2 things at once.
Dim MyCSVFile	'I am going to read a CSV delimited file with this
Set MyCSVFile = New TextFiler
'I'll not set any options - just take defaults of CSV reading.
'This is how I would change the delimiter to tabs if the file uses tabs rather than commas: MyCSVFile.Delimiter = vbTab ' or to tildes: MyCSVFile.Delimiter = "~"

Dim MyFWFile	'I am going to write a fixed width file with this
Set MyFWFile = New TextFiler
MyFWFile.FieldWidths = "3,2,20,9"
MyFWFile.FileReadWrite = 2 'forWriting

'You can use a With statement to avoid explicitly mentioning the "MyCSVFile."  class name every time.
'With MyCSVFile
'End With

'Open the Demo CSV file with error checking
Response.Write("<font face='arial'><b>Delimited File Demo</b><p>")
Response.Write("<b>Opening input CSV file:</b> demo.csv<br>")
if not MyCSVFile.OpenFile("Demo.csv") then
	'The filenames are stored here during the open process
	Response.Write(MyCSVFile.AbsoluteFileName & " (" & MyCSVFile.VirtualFileName & ")<br>")
	Response.Write(MyCSVFile.ErrorText & "<br>")
end if
Response.Write("<b>Opening output fixed width file:</b> demo.txt<br>")
if not MyFWFile.OpenFile("Demo.txt") then
	'The filenames are stored here during the open process
	Response.Write(MyFWFile.AbsoluteFileName & " (" & MyFWFile.VirtualFileName & ")<br>")
	Response.Write(MyFWFile.ErrorText & "<br>")
end if

'Flush now so we can see errors and the 500;100 error page does not take over the screen.
Response.Flush

'Let's display the contents on screen in a table
Response.Write("<table cellpadding='0' cellspacing='1' border='1' style='border-collapse: collapse; font-family: Arial; font-size: 10pt;' bordercolor='#111111'>" & vbCRLF)

' Read each line of the CSV file until the end of the file
While MyCSVFile.ReadLine
	' If you are expecting say 4 columns, then as an extra error check change the number of columns to suite your circumstance (from 3 to n-1).
	' If you don't need the fields array to be a fix size, then just access MyCSVFile.Fields directly.
	' You can't redim the MyCSVFile.Fields array, so we need to pull it local first.
	myLocalFields = MyCSVFile.Fields
	if ubound(myLocalFields,1) < 3 then redim preserve myLocalFields(3)
	
	' Display each field in the table
	Response.Write("<tr>")
	For ArrayIndex = 0 to ubound(myLocalFields,1)
		Response.Write("<td>" & server.HTMLEncode(myLocalFields(ArrayIndex)) & "</td>")
	Next
	Response.Write("</tr>" & vbCRLF)
	
	'Write it to the fixed width file now
	MyFWFile.WriteLine(myLocalFields)
Wend

' Clean up
Response.Write("</table><p>" & MyCSVFile.LineNumber & " rows read & re-written.</font>")

i = MyCSVFile.Delimiter
'It is very important to close a writable file so that it flushed to disk. Destroying the instance of class file will also close open files.
MyCSVFile.CloseFile
MyFWFile.CloseFile
set MyCSVFile = nothing
set MyFWFile = nothing

%>
</body>
</html>